diff -uNrd ircd-ratbox-1.5-2/src/client.c ircd-rb-FDF6.3a/src/client.c
--- ircd-ratbox-1.5-2/src/client.c	Wed Mar 24 19:30:54 2004
+++ ircd-rb-FDF6.3a/src/client.c	Thu Apr  1 16:20:51 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: client.c,v 7.385.2.15 2004/03/25 00:30:54 androsyn Exp $
+ *  $Id: client.c,v 1.4 2004/04/01 21:20:51 jailbird Exp $
  */
 #include "stdinc.h"
 #include "config.h"
@@ -1793,7 +1793,7 @@
  *
  */
 int
-change_local_nick(struct Client *client_p, struct Client *source_p, char *nick)
+change_local_nick(struct Client *client_p, struct Client *source_p, char *nick, time_t ts)
 {
 	/*
 	 ** Client just changing his/her nick. If he/she is
@@ -1801,7 +1801,10 @@
 	 ** on that channel. Propagate notice to other servers.
 	 */
 
-	source_p->tsinfo = CurrentTime;
+	if (ts)
+		source_p->tsinfo = ts;
+	else
+		source_p->tsinfo = CurrentTime;
 
 	if((source_p->localClient->last_nick_change + ConfigFileEntry.max_nick_time) < CurrentTime)
 		source_p->localClient->number_of_nick_changes = 0;
diff -uNrd ircd-ratbox-1.5-2/src/cluster.c ircd-rb-FDF6.3a/src/cluster.c
--- ircd-ratbox-1.5-2/src/cluster.c	Thu May 20 16:35:19 2004
+++ ircd-rb-FDF6.3a/src/cluster.c	Mon May 31 00:02:27 2004
@@ -28,7 +28,7 @@
  * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: cluster.c,v 7.8.2.5 2004/05/20 20:35:19 leeh Exp $
+ * $Id: cluster.c,v 1.3 2004/05/31 04:02:27 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/crypt.c ircd-rb-FDF6.3a/src/crypt.c
--- ircd-ratbox-1.5-2/src/crypt.c	Thu Jun 26 10:03:11 2003
+++ ircd-rb-FDF6.3a/src/crypt.c	Mon Jan 19 22:26:03 2004
@@ -9,7 +9,7 @@
  *  this stuff is worth it, you can buy me a beer in return.  Poul-Henning Kamp
  *  ----------------------------------------------------------------------------
  *  
- *  $Id: crypt.c,v 7.8.4.1 2003/06/26 14:03:11 androsyn Exp $
+ *  $Id: crypt.c,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/descrip.mms ircd-rb-FDF6.3a/src/descrip.mms
--- ircd-ratbox-1.5-2/src/descrip.mms	Thu Jun 26 10:03:11 2003
+++ ircd-rb-FDF6.3a/src/descrip.mms	Mon Jan 19 22:26:03 2004
@@ -1,6 +1,6 @@
 # MMS/MMK Makefile for OpenVMS
 # Copyright (c) 2001 Edward Brocklesby
-# $Id: descrip.mms,v 7.12.2.1 2003/06/26 14:03:11 androsyn Exp $
+# $Id: descrip.mms,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
 
 CC=	CC
 CFLAGS=/INCLUDE_DIRECTORY=([-.INCLUDE],[-.ADNS])/STANDARD=ISOC94/NOWARN -
diff -uNrd ircd-ratbox-1.5-2/src/dynlink.c ircd-rb-FDF6.3a/src/dynlink.c
--- ircd-ratbox-1.5-2/src/dynlink.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/dynlink.c	Thu Apr  1 15:46:06 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- * $Id: dynlink.c,v 7.22.2.3 2004/03/15 18:19:55 leeh Exp $
+ * $Id: dynlink.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  *
  */
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/event.c ircd-rb-FDF6.3a/src/event.c
--- ircd-ratbox-1.5-2/src/event.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/event.c	Thu Apr  1 15:46:06 2004
@@ -39,7 +39,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: event.c,v 7.37.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: event.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 
 /*
diff -uNrd ircd-ratbox-1.5-2/src/fdlist.c ircd-rb-FDF6.3a/src/fdlist.c
--- ircd-ratbox-1.5-2/src/fdlist.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/fdlist.c	Thu Apr  1 15:46:06 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: fdlist.c,v 7.39.2.3 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: fdlist.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 #include "stdinc.h"
 #include "config.h"		/* option settings */
diff -uNrd ircd-ratbox-1.5-2/src/fileio.c ircd-rb-FDF6.3a/src/fileio.c
--- ircd-ratbox-1.5-2/src/fileio.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/fileio.c	Thu Apr  1 15:46:06 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: fileio.c,v 7.29.2.3 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: fileio.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 #include "stdinc.h"
 #include "config.h"
diff -uNrd ircd-ratbox-1.5-2/src/getopt.c ircd-rb-FDF6.3a/src/getopt.c
--- ircd-ratbox-1.5-2/src/getopt.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/getopt.c	Thu Apr  1 15:46:06 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: getopt.c,v 7.19.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: getopt.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/hash.c ircd-rb-FDF6.3a/src/hash.c
--- ircd-ratbox-1.5-2/src/hash.c	Wed Mar 24 19:30:55 2004
+++ ircd-rb-FDF6.3a/src/hash.c	Thu Apr  1 15:46:06 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hash.c,v 7.77.2.3 2004/03/25 00:30:55 androsyn Exp $
+ *  $Id: hash.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/hook.c ircd-rb-FDF6.3a/src/hook.c
--- ircd-ratbox-1.5-2/src/hook.c	Sat Mar 27 18:02:13 2004
+++ ircd-rb-FDF6.3a/src/hook.c	Thu Apr  1 15:46:06 2004
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hook.c,v 7.28.2.2 2004/03/27 23:02:13 leeh Exp $
+ *  $Id: hook.c,v 1.1.1.2 2004/04/01 20:46:06 jailbird Exp $
  */
 
 /* hooks are used by modules to hook into events called by other parts of
diff -uNrd ircd-ratbox-1.5-2/src/hostmask.c ircd-rb-FDF6.3a/src/hostmask.c
--- ircd-ratbox-1.5-2/src/hostmask.c	Tue Mar 23 12:35:54 2004
+++ ircd-rb-FDF6.3a/src/hostmask.c	Thu Apr  1 16:20:51 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hostmask.c,v 7.88.2.3 2004/03/23 17:35:54 leeh Exp $
+ *  $Id: hostmask.c,v 1.3 2004/04/01 21:20:51 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -518,13 +518,10 @@
 	}
 
 	/* hunt for a gline */
-	if(ConfigFileEntry.glines)
-	{
-		kconf = find_conf_by_address(host, ip, CONF_GLINE, aftype, user);
+	kconf = find_conf_by_address(host, ip, CONF_GLINE, aftype, user);
 
-		if((kconf != NULL) && !IsConfExemptGline(iconf))
-			return kconf;
-	}
+	if((kconf != NULL) && !IsConfExemptGline(iconf))
+		return kconf;
 
 	return iconf;
 }
diff -uNrd ircd-ratbox-1.5-2/src/irc_string.c ircd-rb-FDF6.3a/src/irc_string.c
--- ircd-ratbox-1.5-2/src/irc_string.c	Fri Apr  2 10:51:02 2004
+++ ircd-rb-FDF6.3a/src/irc_string.c	Sat Apr  3 18:31:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: irc_string.c,v 7.67.2.4 2004/04/02 15:51:02 androsyn Exp $
+ *  $Id: irc_string.c,v 1.1.1.3 2004/04/03 23:31:59 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/ircd.c ircd-rb-FDF6.3a/src/ircd.c
--- ircd-ratbox-1.5-2/src/ircd.c	Mon May 31 21:02:21 2004
+++ ircd-rb-FDF6.3a/src/ircd.c	Tue Jun  1 12:00:58 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: ircd.c,v 7.294.2.18 2004/06/01 01:02:21 androsyn Exp $
+ *  $Id: ircd.c,v 1.1.1.5 2004/06/01 16:00:58 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/ircd_lexer.l ircd-rb-FDF6.3a/src/ircd_lexer.l
--- ircd-ratbox-1.5-2/src/ircd_lexer.l	Fri Nov 28 11:29:18 2003
+++ ircd-rb-FDF6.3a/src/ircd_lexer.l	Mon Jan 19 22:26:03 2004
@@ -15,7 +15,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- * $Id: ircd_lexer.l,v 1.154.2.2 2003/11/28 16:29:18 leeh Exp $
+ * $Id: ircd_lexer.l,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 %option case-insensitive
diff -uNrd ircd-ratbox-1.5-2/src/ircd_parser.y ircd-rb-FDF6.3a/src/ircd_parser.y
--- ircd-ratbox-1.5-2/src/ircd_parser.y	Fri Aug  8 15:19:27 2003
+++ ircd-rb-FDF6.3a/src/ircd_parser.y	Mon Jan 19 22:26:03 2004
@@ -1,6 +1,6 @@
 /* This code is in the public domain.
  * $Nightmare: nightmare/src/main/parser.y,v 1.2.2.1.2.1 2002/07/02 03:42:10 ejb Exp $
- * $Id: ircd_parser.y,v 1.271.2.2 2003/08/08 19:19:27 leeh Exp $
+ * $Id: ircd_parser.y,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 %{
diff -uNrd ircd-ratbox-1.5-2/src/ircd_signal.c ircd-rb-FDF6.3a/src/ircd_signal.c
--- ircd-ratbox-1.5-2/src/ircd_signal.c	Wed Oct 15 14:07:08 2003
+++ ircd-rb-FDF6.3a/src/ircd_signal.c	Mon Jan 19 22:26:03 2004
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd_signal.c,v 7.18.2.2 2003/10/15 18:07:08 androsyn Exp $
+ * $Id: ircd_signal.c,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/kdparse.c ircd-rb-FDF6.3a/src/kdparse.c
--- ircd-ratbox-1.5-2/src/kdparse.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/kdparse.c	Thu Apr  1 15:46:07 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: kdparse.c,v 7.29.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: kdparse.c,v 1.1.1.2 2004/04/01 20:46:07 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/linebuf.c ircd-rb-FDF6.3a/src/linebuf.c
--- ircd-ratbox-1.5-2/src/linebuf.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/linebuf.c	Sat Jun 19 22:46:11 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: linebuf.c,v 7.109.2.15 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: linebuf.c,v 1.3 2004/04/01 21:20:51 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -573,16 +573,18 @@
 
 	bufline->terminated = 1;
 
+	/* Note: In FDF, we don't send \r. It violates rfc1459, but it makes ircII services cleaner.
+	 * besides, IRCII_KLUDGE did the same thing, and it didn't break anything! -JailBird */
 	/* Truncate the data if required */
 	if(len > 510)
 	{
 		len = 510;
-		bufline->buf[len++] = '\r';
+/*		bufline->buf[len++] = '\r'; */
 		bufline->buf[len++] = '\n';
 	}
 	else if(len == 0)
 	{
-		bufline->buf[len++] = '\r';
+/*		bufline->buf[len++] = '\r'; */
 		bufline->buf[len++] = '\n';
 		bufline->buf[len] = '\0';
 	}
@@ -595,7 +597,7 @@
 			len--;
 		}
 
-		bufline->buf[++len] = '\r';
+/*		bufline->buf[++len] = '\r'; */
 		bufline->buf[++len] = '\n';
 		bufline->buf[++len] = '\0';
 	}
diff -uNrd ircd-ratbox-1.5-2/src/listener.c ircd-rb-FDF6.3a/src/listener.c
--- ircd-ratbox-1.5-2/src/listener.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/listener.c	Thu Apr  1 15:46:07 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: listener.c,v 7.91.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: listener.c,v 1.1.1.2 2004/04/01 20:46:07 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/m_error.c ircd-rb-FDF6.3a/src/m_error.c
--- ircd-ratbox-1.5-2/src/m_error.c	Thu May 20 08:06:52 2004
+++ ircd-rb-FDF6.3a/src/m_error.c	Mon May 31 00:02:27 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_error.c,v 7.33.2.6 2004/05/20 12:06:52 leeh Exp $
+ *  $Id: m_error.c,v 1.3 2004/05/31 04:02:27 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/match.c ircd-rb-FDF6.3a/src/match.c
--- ircd-ratbox-1.5-2/src/match.c	Thu Apr 15 10:17:20 2004
+++ ircd-rb-FDF6.3a/src/match.c	Wed Apr 21 22:08:14 2004
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: match.c,v 7.32.2.4 2004/04/15 14:17:20 androsyn Exp $
+ * $Id: match.c,v 1.1.1.2 2004/04/22 02:08:14 jailbird Exp $
  *
  */
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/memory.c ircd-rb-FDF6.3a/src/memory.c
--- ircd-ratbox-1.5-2/src/memory.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/memory.c	Thu Apr  1 15:46:07 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: memory.c,v 7.44.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: memory.c,v 1.1.1.2 2004/04/01 20:46:07 jailbird Exp $
  */
 
 
diff -uNrd ircd-ratbox-1.5-2/src/messages.tab ircd-rb-FDF6.3a/src/messages.tab
--- ircd-ratbox-1.5-2/src/messages.tab	Mon Apr  5 15:22:56 2004
+++ ircd-rb-FDF6.3a/src/messages.tab	Sat Apr 10 18:52:31 2004
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: messages.tab,v 7.90.2.9 2004/04/05 19:22:56 leeh Exp $
+ *   $Id: messages.tab,v 1.4 2004/04/10 22:52:31 jailbird Exp $
  */
 
 static  const char *  replies[] = {
@@ -265,7 +265,7 @@
 /* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Server Up %d days, %d:%02d:%02d",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %s %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %s", 
-/* 245 RPL_STATSSLINE, */       NULL,
+/* 245 RPL_STATSSLINE, */       ":%s 245 %s %c :%s",
 /* 246 */       NULL,
 /* 247 RPL_STATSXLINE, */       ":%s 247 %s %c %d %s :%s",
 
@@ -432,7 +432,7 @@
 /* 405 ERR_TOOMANYCHANNELS, */  ":%s 405 %s %s :You have joined too many channels",
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */   ":%s 407 %s %s :Too many recipients.",
-/* 408 */       NULL,
+/* 408 ERR_NOCOLORSONCHAN, */	":%s 408 %s %s :You cannot use colors on this channel",
 /* 409 ERR_NOORIGIN, */         ":%s 409 %s :No origin specified",
 /* 410 */       NULL,
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
@@ -460,7 +460,7 @@
 /* 432 ERR_ERRONEUSNICKNAME, */ ":%s 432 %s %s :Erroneous Nickname",
 /* 433 ERR_NICKNAMEINUSE, */    ":%s 433 %s %s :Nickname is already in use.",
 /* 434 */       NULL,
-/* 435 */       NULL,
+/* 435 ERR_BANNICKCHANGE, */	":%s 437 %s %s :Cannot change nickname while banned on channel",
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
 /* 437 ERR_ERR_UNAVAILRESOURCE, */ ":%s 437 %s %s :Nick/channel is temporarily unavailable",
 /* 438 ERR_NICKTOOFAST */       ":%s 438 %s %s %s :Nick change too fast. Please wait %d seconds.",
diff -uNrd ircd-ratbox-1.5-2/src/modules.c ircd-rb-FDF6.3a/src/modules.c
--- ircd-ratbox-1.5-2/src/modules.c	Thu May 20 17:37:59 2004
+++ ircd-rb-FDF6.3a/src/modules.c	Mon May 31 00:02:27 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: modules.c,v 7.127.2.6 2004/05/20 21:37:59 leeh Exp $
+ *  $Id: modules.c,v 1.4 2004/05/31 04:02:27 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -548,6 +548,7 @@
 	mod_add_cmd(&etrace_msgtab);
 	mod_add_cmd(&gline_msgtab);
 	mod_add_cmd(&help_msgtab);
+	mod_add_cmd(&idle_msgtab);
 	mod_add_cmd(&info_msgtab);
 	mod_add_cmd(&invite_msgtab);
 	mod_add_cmd(&ison_msgtab);
@@ -586,6 +587,7 @@
 	mod_add_cmd(&server_msgtab);
 	mod_add_cmd(&set_msgtab);
 	mod_add_cmd(&sjoin_msgtab);
+	mod_add_cmd(&snick_msgtab);
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
diff -uNrd ircd-ratbox-1.5-2/src/motd.c ircd-rb-FDF6.3a/src/motd.c
--- ircd-ratbox-1.5-2/src/motd.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/motd.c	Thu Apr  1 15:46:07 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: motd.c,v 7.34.4.3 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: motd.c,v 1.1.1.2 2004/04/01 20:46:07 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/newconf.c ircd-rb-FDF6.3a/src/newconf.c
--- ircd-ratbox-1.5-2/src/newconf.c	Wed Apr  7 16:37:50 2004
+++ ircd-rb-FDF6.3a/src/newconf.c	Tue Jun  1 20:20:15 2004
@@ -1,5 +1,5 @@
 /* This code is in the public domain.
- * $Id: newconf.c,v 7.93.2.22 2004/04/07 20:37:50 androsyn Exp $
+ * $Id: newconf.c,v 1.5 2004/06/02 00:20:15 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -2156,6 +2156,45 @@
 }
 
 static int
+conf_begin_service(struct TopConf *tc)
+{
+	if(yy_aconf)
+	{
+		free_conf(yy_aconf);
+		yy_aconf = NULL;
+	}
+
+	yy_aconf = make_conf();
+	yy_aconf->status = CONF_SLINE;
+	yy_aconf->passwd = NULL;
+	return 0;
+}
+
+static int
+conf_end_service(struct TopConf *tc)
+{
+	if(yy_aconf->host)
+		conf_add_s_conf(yy_aconf);
+	else
+	{
+		conf_report_error("Ignoring service -- invalid service::name.");
+		free_conf(yy_aconf);
+	}
+
+	yy_aconf = NULL;
+
+	return 0;
+}
+
+static void
+conf_set_service_name(void *data)
+{
+	MyFree(yy_aconf->host);
+	DupString(yy_aconf->host, data);
+	collapse(yy_aconf->host);
+}
+
+static int
 conf_begin_cluster(struct TopConf *tc)
 {
 	yy_cconf = make_cluster();
@@ -2395,12 +2434,6 @@
 }
 
 static void
-conf_set_general_glines(void *data)
-{
-	ConfigFileEntry.glines = *(unsigned int *) data;
-}
-
-static void
 conf_set_general_message_locale(void *data)
 {
 	char langenv[BUFSIZE];
@@ -2558,6 +2591,61 @@
 #endif
 
 static void
+conf_set_general_check_clone(void *data)
+{
+	ConfigFileEntry.check_clone = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_check_clone_limit(void *data)
+{
+	ConfigFileEntry.check_clone_limit = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_check_clone_period(void *data)
+{
+	ConfigFileEntry.check_clone_period = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_check_clone_delay(void *data)
+{
+	ConfigFileEntry.check_clone_delay = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_inu_hack_passwd(void *data)
+{
+	MyFree(ConfigFileEntry.inu_hack_passwd);
+	DupString(ConfigFileEntry.inu_hack_passwd, data);
+}
+
+static void
+conf_set_general_inu_server_can_op(void *data)
+{
+	ConfigFileEntry.inu_server_can_op = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_inu_ignore_bans(void *data)
+{
+	ConfigFileEntry.inu_ignore_bans = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_inu_serv_can_collide(void *data)
+{
+	ConfigFileEntry.inu_serv_can_collide = *(unsigned int *) data;
+}
+
+static void
+conf_set_general_jb_serv_can_kick(void *data)
+{
+	ConfigFileEntry.jb_serv_can_kick = *(unsigned int *) data;
+}
+
+static void
 conf_set_general_oper_umodes(void *data)
 {
 	set_modes_from_table(&ConfigFileEntry.oper_umodes, "umode", umode_table, data);
@@ -2734,9 +2822,15 @@
 }
 
 static void
-conf_set_channel_burst_topicwho(void *data)
+conf_set_channel_opers_see_hidden(void *data)
 {
-	ConfigChannel.burst_topicwho = *(unsigned int *) data;
+	ConfigChannel.opers_see_hidden = *(unsigned int *) data;
+}
+
+static void
+conf_set_channel_opers_see_topic(void *data)
+{
+	ConfigChannel.opers_see_topic = *(unsigned int *) data;
 }
 
 static void
@@ -3118,6 +3212,9 @@
 	add_conf_item("gecos", "reason", CF_QSTRING, conf_set_gecos_reason);
 	add_conf_item("gecos", "action", CF_STRING, conf_set_gecos_action);
 
+	add_top_conf("service", conf_begin_service, conf_end_service);
+	add_conf_item("service", "name", CF_QSTRING, conf_set_service_name);
+
 	add_top_conf("cluster", conf_begin_cluster, conf_end_cluster);
 	add_conf_item("cluster", "name", CF_QSTRING, conf_set_cluster_name);
 	add_conf_item("cluster", "type", CF_STRING | CF_FLIST, conf_set_cluster_type);
@@ -3161,7 +3258,6 @@
 	add_conf_item("general", "pace_wait_simple", CF_TIME, conf_set_general_pace_wait_simple);
 	add_conf_item("general", "short_motd", CF_YESNO, conf_set_general_short_motd);
 	add_conf_item("general", "no_oper_flood", CF_YESNO, conf_set_general_no_oper_flood);
-	add_conf_item("general", "glines", CF_YESNO, conf_set_general_glines);
 	add_conf_item("general", "gline_time", CF_TIME, conf_set_general_gline_time);
 	add_conf_item("general", "gline_min_cidr", CF_INT, conf_set_general_gline_min_cidr);
 	add_conf_item("general", "gline_min_cidr6", CF_INT, conf_set_general_gline_min_cidr6);
@@ -3204,6 +3300,16 @@
 	add_conf_item("general", "fallback_to_ip6_int", CF_YESNO,
 		      conf_set_general_fallback_to_ip6_int);
 #endif
+	add_conf_item("general", "check_clone", CF_YESNO, conf_set_general_check_clone);
+	add_conf_item("general", "check_clone_limit", CF_INT, conf_set_general_check_clone_limit);
+	add_conf_item("general", "check_clone_period", CF_TIME, conf_set_general_check_clone_period);
+	add_conf_item("general", "check_clone_delay", CF_TIME, conf_set_general_check_clone_delay);
+	add_conf_item("general", "inu_hack_passwd", CF_QSTRING, conf_set_general_inu_hack_passwd);
+	add_conf_item("general", "inu_server_can_op", CF_YESNO, conf_set_general_inu_server_can_op);
+	add_conf_item("general", "inu_ignore_bans", CF_YESNO, conf_set_general_inu_ignore_bans);
+	add_conf_item("general", "inu_serv_can_collide", CF_YESNO, conf_set_general_inu_serv_can_collide);
+	add_conf_item("general", "jb_serv_can_kick", CF_YESNO, conf_set_general_jb_serv_can_kick);
+
 	add_top_conf("channel", NULL, NULL);
 	add_conf_item("channel", "use_except", CF_YESNO, conf_set_channel_use_except);
 	add_conf_item("channel", "use_invex", CF_YESNO, conf_set_channel_use_invex);
@@ -3224,7 +3330,8 @@
 		      conf_set_channel_no_create_on_split);
 	add_conf_item("channel", "no_join_on_split", CF_YESNO, conf_set_channel_no_join_on_split);
 	add_conf_item("channel", "no_oper_resvs", CF_YESNO, conf_set_channel_no_oper_resvs);
-	add_conf_item("channel", "burst_topicwho", CF_YESNO, conf_set_channel_burst_topicwho);
+	add_conf_item("channel", "opers_see_hidden", CF_YESNO, conf_set_channel_opers_see_hidden);
+	add_conf_item("channel", "opers_see_topic", CF_YESNO, conf_set_channel_opers_see_topic);
 
 	add_top_conf("serverhide", NULL, NULL);
 	add_conf_item("serverhide", "flatten_links", CF_YESNO, conf_set_serverhide_flatten_links);
diff -uNrd ircd-ratbox-1.5-2/src/numeric.c ircd-rb-FDF6.3a/src/numeric.c
--- ircd-ratbox-1.5-2/src/numeric.c	Mon Mar 15 13:19:55 2004
+++ ircd-rb-FDF6.3a/src/numeric.c	Thu Apr  1 16:20:51 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: numeric.c,v 7.26.2.2 2004/03/15 18:19:55 leeh Exp $
+ *  $Id: numeric.c,v 1.3 2004/04/01 21:20:51 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -50,7 +50,7 @@
 
 	s_assert(-1 < numeric);
 	s_assert(numeric < ERR_LAST_ERR_MSG);
-	s_assert(0 != replies[numeric]);
+/*	s_assert(0 != replies[numeric]); */
 
 	if(numeric > ERR_LAST_ERR_MSG)
 		numeric = ERR_LAST_ERR_MSG;
diff -uNrd ircd-ratbox-1.5-2/src/packet.c ircd-rb-FDF6.3a/src/packet.c
--- ircd-ratbox-1.5-2/src/packet.c	Wed Jun 16 23:24:34 2004
+++ ircd-rb-FDF6.3a/src/packet.c	Thu Jun 17 13:09:10 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: packet.c,v 7.118.2.4 2004/06/17 03:24:34 androsyn Exp $
+ *  $Id: packet.c,v 1.1.1.3 2004/06/17 17:09:10 jailbird Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
diff -uNrd ircd-ratbox-1.5-2/src/parse.c ircd-rb-FDF6.3a/src/parse.c
--- ircd-ratbox-1.5-2/src/parse.c	Thu May 20 08:06:52 2004
+++ ircd-rb-FDF6.3a/src/parse.c	Mon May 31 00:02:28 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: parse.c,v 7.160.2.7 2004/05/20 12:06:52 leeh Exp $
+ *  $Id: parse.c,v 1.3 2004/05/31 04:02:28 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/patricia.c ircd-rb-FDF6.3a/src/patricia.c
--- ircd-ratbox-1.5-2/src/patricia.c	Thu Jun 26 10:03:17 2003
+++ ircd-rb-FDF6.3a/src/patricia.c	Thu Jun 17 14:57:30 2004
@@ -1,7 +1,7 @@
 /*
  * Yanked out of Net::Patricia by Aaron Sethman <androsyn@ratbox.org>
  *
- * $Id: patricia.c,v 7.19.2.1 2003/06/26 14:03:17 androsyn Exp $
+ * $Id: patricia.c,v 1.4 2004/06/17 18:57:30 jailbird Exp $
  * Dave Plonka <plonka@doit.wisc.edu>
  *
  * This product includes software developed by the University of Michigan,
@@ -212,7 +212,7 @@
 		memcpy(save, string, cp - string);
 		save[cp - string] = '\0';
 		string = save;
-		if(bitlen < 0 || bitlen > maxbitlen)
+		if(bitlen > maxbitlen)
 			bitlen = maxbitlen;
 	}
 	else
diff -uNrd ircd-ratbox-1.5-2/src/reject.c ircd-rb-FDF6.3a/src/reject.c
--- ircd-ratbox-1.5-2/src/reject.c	Wed May 19 19:19:32 2004
+++ ircd-rb-FDF6.3a/src/reject.c	Mon May 31 00:02:28 2004
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: reject.c,v 1.4.2.15 2004/05/19 23:19:32 leeh Exp $
+ *  $Id: reject.c,v 1.3 2004/05/31 04:02:28 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/restart.c ircd-rb-FDF6.3a/src/restart.c
--- ircd-ratbox-1.5-2/src/restart.c	Mon Mar 15 13:19:56 2004
+++ ircd-rb-FDF6.3a/src/restart.c	Thu Apr  1 15:46:08 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: restart.c,v 7.28.2.2 2004/03/15 18:19:56 leeh Exp $
+ *  $Id: restart.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/resv.c ircd-rb-FDF6.3a/src/resv.c
--- ircd-ratbox-1.5-2/src/resv.c	Wed Jun  2 22:18:01 2004
+++ ircd-rb-FDF6.3a/src/resv.c	Sun Jun  6 01:10:47 2004
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: resv.c,v 7.30.2.5 2004/06/03 02:18:01 androsyn Exp $
+ *  $Id: resv.c,v 1.1.1.3 2004/06/06 05:10:47 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/rsa.c ircd-rb-FDF6.3a/src/rsa.c
--- ircd-ratbox-1.5-2/src/rsa.c	Sun Mar 28 17:38:18 2004
+++ ircd-rb-FDF6.3a/src/rsa.c	Thu Apr  1 15:46:08 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: rsa.c,v 7.32.2.4 2004/03/28 22:38:18 leeh Exp $
+ *  $Id: rsa.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_auth.c ircd-rb-FDF6.3a/src/s_auth.c
--- ircd-ratbox-1.5-2/src/s_auth.c	Mon Mar 15 13:19:56 2004
+++ ircd-rb-FDF6.3a/src/s_auth.c	Thu Apr  1 15:46:08 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_auth.c,v 7.149.2.10 2004/03/15 18:19:56 leeh Exp $
+ *  $Id: s_auth.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 /*
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd.c ircd-rb-FDF6.3a/src/s_bsd.c
--- ircd-ratbox-1.5-2/src/s_bsd.c	Sat Apr  3 16:11:13 2004
+++ ircd-rb-FDF6.3a/src/s_bsd.c	Sat Apr 10 18:44:55 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd.c,v 7.205.2.7 2004/04/03 21:11:13 leeh Exp $
+ *  $Id: s_bsd.c,v 1.1.1.4 2004/04/10 22:44:55 jailbird Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd_devpoll.c ircd-rb-FDF6.3a/src/s_bsd_devpoll.c
--- ircd-ratbox-1.5-2/src/s_bsd_devpoll.c	Mon Mar 15 13:19:56 2004
+++ ircd-rb-FDF6.3a/src/s_bsd_devpoll.c	Thu Apr  1 15:46:08 2004
@@ -22,7 +22,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_devpoll.c,v 7.25.2.3 2004/03/15 18:19:56 leeh Exp $
+ *  $Id: s_bsd_devpoll.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd_epoll.c ircd-rb-FDF6.3a/src/s_bsd_epoll.c
--- ircd-ratbox-1.5-2/src/s_bsd_epoll.c	Mon Mar 15 13:19:56 2004
+++ ircd-rb-FDF6.3a/src/s_bsd_epoll.c	Thu Apr  1 15:46:08 2004
@@ -23,7 +23,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_epoll.c,v 1.11.2.4 2004/03/15 18:19:56 leeh Exp $
+ *  $Id: s_bsd_epoll.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd_kqueue.c ircd-rb-FDF6.3a/src/s_bsd_kqueue.c
--- ircd-ratbox-1.5-2/src/s_bsd_kqueue.c	Tue Apr 20 22:54:48 2004
+++ ircd-rb-FDF6.3a/src/s_bsd_kqueue.c	Wed Apr 21 22:08:15 2004
@@ -22,7 +22,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_kqueue.c,v 1.38.2.12 2004/04/21 02:54:48 androsyn Exp $
+ *  $Id: s_bsd_kqueue.c,v 1.1.1.3 2004/04/22 02:08:15 jailbird Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd_poll.c ircd-rb-FDF6.3a/src/s_bsd_poll.c
--- ircd-ratbox-1.5-2/src/s_bsd_poll.c	Mon Jun 14 23:09:02 2004
+++ ircd-rb-FDF6.3a/src/s_bsd_poll.c	Wed Jun 16 13:41:36 2004
@@ -22,7 +22,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_poll.c,v 7.69.2.6 2004/06/15 03:09:02 androsyn Exp $
+ *  $Id: s_bsd_poll.c,v 1.1.1.5 2004/06/16 17:41:36 jailbird Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-ratbox-1.5-2/src/s_bsd_select.c ircd-rb-FDF6.3a/src/s_bsd_select.c
--- ircd-ratbox-1.5-2/src/s_bsd_select.c	Mon Mar 15 13:19:56 2004
+++ ircd-rb-FDF6.3a/src/s_bsd_select.c	Thu Apr  1 15:46:08 2004
@@ -22,7 +22,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_select.c,v 7.36.2.3 2004/03/15 18:19:56 leeh Exp $
+ *  $Id: s_bsd_select.c,v 1.1.1.2 2004/04/01 20:46:08 jailbird Exp $
  */
 
 #include "config.h"
